function BuildConfigDialog()
	optionsPanel = Turbine.UI.Control();
	optionsPanel:SetSize(250, 320 );
	
	BuildBloc(optionsPanel);
	
	return optionsPanel;
end

function BuildBloc(parent)
	local optDiversTitleLabel = Turbine.UI.Label();
	optDiversTitleLabel:SetParent( parent );
	optDiversTitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	optDiversTitleLabel:SetText("Configuration du lanceur :");
	optDiversTitleLabel:SetPosition( 15, 15 );
	optDiversTitleLabel:SetSize(300, 20);
	optDiversTitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	optDiversTitleLabel:SetMouseVisible( false );
	
	local defaultButton=Turbine.UI.Lotro.Button();
	defaultButton:SetParent(parent);
	defaultButton:SetPosition( 15, 40 );
	defaultButton:SetSize(250,20);
	defaultButton:SetText("Configuration par défaut");
	defaultButton:SetParent(optionsPanel);
	
	local canMoveQuicklauncherCheckbox = Turbine.UI.Lotro.CheckBox();
	canMoveQuicklauncherCheckbox:SetParent(parent);
	canMoveQuicklauncherCheckbox:SetMultiline( false );
	canMoveQuicklauncherCheckbox:SetPosition( 15, 65 );
	canMoveQuicklauncherCheckbox:SetSize( 360, 20 );
	canMoveQuicklauncherCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	canMoveQuicklauncherCheckbox:SetText("Permettre le déplacement à la souris");
	canMoveQuicklauncherCheckbox:SetChecked(settings.canMoveQuickLauncher);
	canMoveQuicklauncherCheckbox:SetMouseVisible( false );
	canMoveQuicklauncherCheckbox.CheckedChanged = function(sender, args)
		settings.canMoveQuickLauncher = canMoveQuicklauncherCheckbox:IsChecked();
		SaveSettings();
	end
	local useQuickLauncherCheckbox = Turbine.UI.Lotro.CheckBox();
	useQuickLauncherCheckbox:SetParent(parent);
	useQuickLauncherCheckbox:SetMultiline( false );
	useQuickLauncherCheckbox:SetPosition( 15, 85 );
	useQuickLauncherCheckbox:SetSize( 360, 20 );
	useQuickLauncherCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	useQuickLauncherCheckbox:SetText("Afficher un lanceur rapide");
	useQuickLauncherCheckbox:SetChecked(settings.useQuickLauncher);
	useQuickLauncherCheckbox:SetMouseVisible( false );
	useQuickLauncherCheckbox.CheckedChanged = function(sender, args)
		settings.useQuickLauncher = useQuickLauncherCheckbox:IsChecked();
		SaveSettings();
	end			
	local autoShowOnLaunchCheckbox = Turbine.UI.Lotro.CheckBox();
	autoShowOnLaunchCheckbox:SetParent(parent);
	autoShowOnLaunchCheckbox:SetMultiline( false );
	autoShowOnLaunchCheckbox:SetPosition( 15, 105 );
	autoShowOnLaunchCheckbox:SetSize( 360, 20 );
	autoShowOnLaunchCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	autoShowOnLaunchCheckbox:SetText( "Ouvrir la fenêtre principale au lancement");
	autoShowOnLaunchCheckbox:SetChecked(settings.autoShowOnLaunch);
	autoShowOnLaunchCheckbox:SetMouseVisible( false );
	autoShowOnLaunchCheckbox.CheckedChanged = function(sender, args)
		settings.autoShowOnLaunch = autoShowOnLaunchCheckbox:IsChecked();
		SaveSettings();
	end		
	local animateQuickLaunchCheckbox = Turbine.UI.Lotro.CheckBox();
	animateQuickLaunchCheckbox:SetParent(parent);
	animateQuickLaunchCheckbox:SetMultiline( false );
	animateQuickLaunchCheckbox:SetPosition( 15, 125 );
	animateQuickLaunchCheckbox:SetSize( 360, 20 );
	animateQuickLaunchCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	animateQuickLaunchCheckbox:SetText( "Animer le lanceur rapide" );
	animateQuickLaunchCheckbox:SetChecked(settings.animateQuickLauncher);
	animateQuickLaunchCheckbox:SetMouseVisible( false );
	animateQuickLaunchCheckbox.CheckedChanged = function(sender, args)
		settings.animateQuickLauncher = animateQuickLaunchCheckbox:IsChecked();
		SaveSettings();
	end		
		-- local elementList = {};
	-- local selectedElement = nil;
	-- for i = 20, 90, 10 do
		-- local value = i.." %";
		-- table.insert(elementList, value);
		-- if(i==settings.defaultOpacity)then
			-- selectedElement = value;
		-- end
	-- end
	-- local opacityLabel = Turbine.UI.Label();
	-- opacityLabel:SetParent( parent );
	-- opacityLabel:SetMultiline( false );
	-- opacityLabel:SetPosition( 15, 151 );
	-- opacityLabel:SetSize( 360, 20 );
	-- opacityLabel:SetText( "Opacit\195\169 du lanceur :" );
	-- local opacityDropDown = DropDown.Create(elementList, selectedElement); -- table that contains the list, default selected value for the list
	-- opacityDropDown:SetParent(parent);
	-- opacityDropDown:SetPosition( 170, 146 );
	-- opacityDropDown.myElementList = elementList;
	-- opacityDropDown:ApplyWidth(75); -- set the width of the menu, this is not essential to include as the default is a good size.
	-- opacityDropDown:SetMaxItems(8); -- Number of items to display in the drop down before a scrollbar is needed.. default value is 7 where this is excluded.
	-- opacityDropDown:SetVisible(true);
	-- opacityDropDown.ItemChanged = function ()		
		-- local selectedOpacity = opacityDropDown:GetText();	
		-- local opacity = string.match(selectedOpacity, '%d+');		
		-- if(opacity ~= nil) then settings.defaultOpacity = tonumber(opacity); end
		-- SaveSettings();	
	-- end	
	local opacityLabel = Turbine.UI.Label();
	opacityLabel:SetParent( parent );
	opacityLabel:SetMultiline( false );
	opacityLabel:SetPosition( 15, 150 );
	opacityLabel:SetSize( 360, 20 );
	opacityLabel:SetText( "Opacit\195\169 du lanceur :" );
	local opacityTextBox = Turbine.UI.Label();
	opacityTextBox:SetParent( parent );
	opacityTextBox:SetMultiline( false );
	opacityTextBox:SetPosition( 170, 150 );
	opacityTextBox:SetSize( 250, 20 );
	opacityTextBox:SetEnabled( false );
	--opacityTextBox:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	opacityTextBox:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opacityTextBox.customValue = tonumber(settings.defaultOpacity);
	opacityTextBox:SetText( settings.defaultOpacity.." %" );
	local opacityMinusButton=Turbine.UI.Lotro.Button();
	opacityMinusButton:SetParent(parent);
	opacityMinusButton:SetPosition( 210, 145 );
	opacityMinusButton:SetSize(16,16);
	opacityMinusButton:SetText("-");
	local opacityAddButton=Turbine.UI.Lotro.Button();
	opacityAddButton:SetParent(parent);
	opacityAddButton:SetPosition( 250, 145 );
	opacityAddButton:SetSize(16,16);
	opacityAddButton:SetText("+");	
	opacityMinusButton:SetEnabled(opacityTextBox.customValue>20);
	opacityAddButton:SetEnabled(opacityTextBox.customValue<100);	
	opacityMinusButton.MouseClick=function(sender,args)
		UpdateOpacity(opacityTextBox.customValue-10);
	end
	opacityAddButton.MouseClick=function(sender,args)
		UpdateOpacity(opacityTextBox.customValue+10);

	end
	
	-- local optDiversTitleLabel2 = Turbine.UI.Label();
	-- optDiversTitleLabel2:SetParent( parent );
	-- optDiversTitleLabel2:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	-- optDiversTitleLabel2:SetText(translate("OPTIONS_BLOC2_TITLE"));
	-- optDiversTitleLabel2:SetPosition( 15, 180 );
	-- optDiversTitleLabel2:SetSize(300, 20);
	-- optDiversTitleLabel2:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	-- optDiversTitleLabel2:SetMouseVisible( false );
	-- local autoSynchroCheckbox = Turbine.UI.Lotro.CheckBox();
	-- autoSynchroCheckbox:SetParent(parent);
	-- autoSynchroCheckbox:SetMultiline( false );
	-- autoSynchroCheckbox:SetPosition( 15, 195 );
	-- autoSynchroCheckbox:SetSize( 360, 20 );
	-- autoSynchroCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	-- autoSynchroCheckbox:SetText( translate("OPTIONS_BLOC2_AUTOSYNCHRO" ));
	-- autoSynchroCheckbox:SetChecked(settings.autoSynchro);
	-- autoSynchroCheckbox:SetMouseVisible( false );
	-- autoSynchroCheckbox.CheckedChanged = function(sender, args)
		-- settings.autoSynchro = autoSynchroCheckbox:IsChecked();
		-- saveSettings();
	-- end
	-- local haveChronoCheckbox = Turbine.UI.Lotro.CheckBox();
	-- haveChronoCheckbox:SetParent(parent);
	-- haveChronoCheckbox:SetMultiline( false );
	-- haveChronoCheckbox:SetPosition( 15, 215 );
	-- haveChronoCheckbox:SetSize( 360, 20 );
	-- haveChronoCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	-- haveChronoCheckbox:SetText( translate("OPTIONS_BLOC2_HAVECHRONO" ));
	-- haveChronoCheckbox:SetChecked(settings.haveChrono);
	-- haveChronoCheckbox:SetMouseVisible( false );
	-- haveChronoCheckbox.CheckedChanged = function(sender, args)
		-- settings.haveChrono = haveChronoCheckbox:IsChecked();
		-- SaveSettings();
	-- end				
	
	function UpdateOpacity(value)		
		if(value==nil) then
			return;
		elseif(value>100) then
			opacityTextBox.customValue = 100;
		elseif(value<20) then
			opacityTextBox.customValue = 20;
		else
			opacityTextBox.customValue = value
		end
		opacityTextBox:SetText( opacityTextBox.customValue.." %" );	
		settings.defaultOpacity = string.match(opacityTextBox.customValue, '%d+');			
		opacityMinusButton:SetEnabled(opacityTextBox.customValue>20);
		opacityAddButton:SetEnabled(opacityTextBox.customValue<100);
		SaveSettings();
	end
	
	defaultButton.MouseClick=function(sender,args)
		UpdateOpacity(60);
		settings.canMoveQuickLauncher = false;
		settings.useQuickLauncher = true;
		settings.autoShowOnLaunch = false;
		ResetQuicklaunchPosition();
		SaveSettings();
		autoShowOnLaunchCheckbox:SetChecked(settings.autoShowOnLaunch);
		useQuickLauncherCheckbox:SetChecked(settings.useQuickLauncher);
		canMoveQuicklauncherCheckbox:SetChecked(settings.canMoveQuickLauncher);
		animateQuickLaunchCheckbox:SetChecked(settings.animateQuickLaunchCheckbox);
	end		
	
	local optBlablaCraneTitleLabel = Turbine.UI.Label();
	optBlablaCraneTitleLabel:SetParent( parent );
	optBlablaCraneTitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	optBlablaCraneTitleLabel:SetText("Configuration de BlaBlaCrane :");
	optBlablaCraneTitleLabel:SetPosition( 15, 180 );
	optBlablaCraneTitleLabel:SetSize(300, 20);
	optBlablaCraneTitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	optBlablaCraneTitleLabel:SetMouseVisible( false );
	
	if(settings.blablaTime==nil) then settings.blablaTime = 15; end
	local bubbleTimeLabel = Turbine.UI.Label();
	bubbleTimeLabel:SetParent( parent );
	bubbleTimeLabel:SetMultiline( false );
	bubbleTimeLabel:SetPosition( 15, 200 );
	bubbleTimeLabel:SetSize( 360, 20 );
	bubbleTimeLabel:SetText( "Durée d'affichage des bulles :" );
	local bubbleTimeBackground = Turbine.UI.Window();
	bubbleTimeBackground:SetParent( parent );	
	bubbleTimeBackground:SetSize(60, 16);
	bubbleTimeBackground:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	bubbleTimeBackground:SetPosition( 240, 196 );
	bubbleTimeBackground:SetVisible(true);
	bubbleTimeBackground:SetMouseVisible(false);		
	local bubbleTimeTextArea =  Turbine.UI.TextBox();
	bubbleTimeTextArea:SetParent(bubbleTimeBackground);
	bubbleTimeTextArea:SetText(settings.blablaTime	);
	bubbleTimeTextArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	bubbleTimeTextArea:SetPosition( 1, 1 );
	bubbleTimeTextArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	bubbleTimeTextArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	bubbleTimeTextArea:SetSize(58, 14);
	bubbleTimeTextArea:SetMultiline(false);
	bubbleTimeTextArea.previousvalue = settings.blablaTime;
	bubbleTimeTextArea.FocusGained = function(sender, args)
		bubbleTimeTextArea.previousvalue = bubbleTimeTextArea:GetText();
	end	
	bubbleTimeTextArea.FocusLost = function(sender, args)
		local value = bubbleTimeTextArea:GetText();
		local pos = string.match(value, '%d+');
		if(pos==nil) then pos = bubbleTimeTextArea.previousvalue; else pos = tonumber(pos); bubbleTimeTextArea.previousvalue=pos; settings.blablaTime=pos; SaveSettings(); end
		bubbleTimeTextArea:SetText(pos);
	end

	local loadKillCounterCheckbox = Turbine.UI.Lotro.CheckBox();
	loadKillCounterCheckbox:SetParent(parent);
	loadKillCounterCheckbox:SetMultiline( false );
	loadKillCounterCheckbox:SetPosition( 15, 215 );
	loadKillCounterCheckbox:SetSize( 360, 20 );
	loadKillCounterCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	loadKillCounterCheckbox:SetText("Charger le compteur de kills");
	loadKillCounterCheckbox:SetChecked(settings.loadKillCounter==nil or settings.loadKillCounter);
	loadKillCounterCheckbox:SetMouseVisible( false );
	loadKillCounterCheckbox.CheckedChanged = function(sender, args)
		settings.loadKillCounter = loadKillCounterCheckbox:IsChecked();
		SaveSettings();
	end	
	local loadDeathsCounterCheckbox = Turbine.UI.Lotro.CheckBox();
	loadDeathsCounterCheckbox:SetParent(parent);
	loadDeathsCounterCheckbox:SetMultiline( false );
	loadDeathsCounterCheckbox:SetPosition( 15, 235 );
	loadDeathsCounterCheckbox:SetSize( 360, 20 );
	loadDeathsCounterCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	loadDeathsCounterCheckbox:SetText("Charger le compteur de morts");
	loadDeathsCounterCheckbox:SetChecked(settings.loadDeathsCounter==nil or settings.loadDeathsCounter);
	loadDeathsCounterCheckbox:SetMouseVisible( false );
	loadDeathsCounterCheckbox.CheckedChanged = function(sender, args)
		settings.loadDeathsCounter = loadDeathsCounterCheckbox:IsChecked();
		SaveSettings();
	end	
	local loadDiceListerCheckbox = Turbine.UI.Lotro.CheckBox();
	loadDiceListerCheckbox:SetParent(parent);
	loadDiceListerCheckbox:SetMultiline( false );
	loadDiceListerCheckbox:SetPosition( 15, 255 );
	loadDiceListerCheckbox:SetSize( 360, 20 );
	loadDiceListerCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	loadDiceListerCheckbox:SetText("Charger l'analyse des dés");
	loadDiceListerCheckbox:SetChecked(settings.loadDiceLister==nil or settings.loadDiceLister);
	loadDiceListerCheckbox:SetMouseVisible( false );
	loadDiceListerCheckbox.CheckedChanged = function(sender, args)
		settings.loadDiceLister = loadDiceListerCheckbox:IsChecked();
		SaveSettings();
	end	
	local loadSkirmishDetectorCheckbox = Turbine.UI.Lotro.CheckBox();
	loadSkirmishDetectorCheckbox:SetParent(parent);
	loadSkirmishDetectorCheckbox:SetMultiline( false );
	loadSkirmishDetectorCheckbox:SetPosition( 15, 275 );
	loadSkirmishDetectorCheckbox:SetSize( 360, 20 );
	loadSkirmishDetectorCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	loadSkirmishDetectorCheckbox:SetText("Charger le detecteur de lieutenants");
	loadSkirmishDetectorCheckbox:SetChecked(settings.loadSkirmishDetector==nil or settings.loadSkirmishDetector);
	loadSkirmishDetectorCheckbox:SetMouseVisible( false );
	loadSkirmishDetectorCheckbox.CheckedChanged = function(sender, args)
		settings.loadSkirmishDetector = loadSkirmishDetectorCheckbox:IsChecked();
		SaveSettings();
	end	
	local loadAutoHelloCheckbox = Turbine.UI.Lotro.CheckBox();
	loadAutoHelloCheckbox:SetParent(parent);
	loadAutoHelloCheckbox:SetMultiline( false );
	loadAutoHelloCheckbox:SetPosition( 15, 295 );
	loadAutoHelloCheckbox:SetSize( 360, 20 );
	loadAutoHelloCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	loadAutoHelloCheckbox:SetText("Charger le compteur de kills");
	loadAutoHelloCheckbox:SetChecked(settings.loadAutoHello==nil or settings.loadAutoHello);
	loadAutoHelloCheckbox:SetMouseVisible( false );
	loadAutoHelloCheckbox.CheckedChanged = function(sender, args)
		settings.loadAutoHello = loadAutoHelloCheckbox:IsChecked();
		SaveSettings();
	end	
end