LeaderBoard = class();

function LeaderBoard:Constructor()
	self:GetMenu();
	self:InitChatLogger();
	self.total = 0;
end

function LeaderBoard:InitChatLogger()
	if(Turbine.Chat.receivedListerners == nil) then
		Turbine.Chat.receivedListerners = {};
		Turbine.Chat.Received = function (sender, args)
			for i, j in pairs(Turbine.Chat.receivedListerners) do
				j:OnReceived(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Chat.receivedListerners ~= nil) then
		for i, j in pairs(Turbine.Chat.receivedListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Chat.receivedListerners, self);
		--Turbine.Shell.WriteLine( "LeaderBoard ECHO: "..table.getn(Turbine.Chat.receivedListerners));
	end	
end

function LeaderBoard:OnReceived(sender, args)
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD> LeaderBoard: args.ChatType="..args.ChatType);
	if args.ChatType == 43 then
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD> LeaderBoard:OnReceived");
		local tempMessage = tostring(args.Message);
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Message : "..tempMessage.."</rgb>");

		local x, y, wbName = string.find(tempMessage, "jour avec votre score de (.*) !");	
		if(wbName ~= nil) then
			Turbine.Shell.WriteLine("<rgb=#FF5CCD>Votre classement : "..wbName.."</rgb>"); -- OK
			createBubblePopup("Votre classement : "..wbName):SetVisible(true);
			self.score = wbName;
			settings.leaderboardValue = wbName;
			self:UpdateLeafText();
			SaveSettings();
		end
	end
end

function LeaderBoard:UpdateLeafText()
	if(self.kmenu~=nil) then
		if(settings.leaderboardValue == nil) then
			self.kmenu:SetText("Leaderboard : Unknown");
		else
			self.score = settings.leaderboardValue;
			self.kmenu:SetText("Leaderboard : "..self.score.." pts");
		end
	end
end

function LeaderBoard:GetLeaf(name)
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name==name) then
			return leaf;
		end
	end
	return nil;
end

function LeaderBoard:GetMenu()
	if(self.kmenu == nil) then
		if(settings.leaderboardValue == nil) then
			self.kmenu = Turbine.UI.MenuItem("Leaderboard : Unknown");
		else
			self.score = settings.leaderboardValue;
			self.kmenu = Turbine.UI.MenuItem("Leaderboard : "..self.score.." pts");
		end
	end
	return self.kmenu;
end

function LeaderBoard:Share(canal)
	local shareMsg = "<rgb=#FF0000>"..FromUTF8("Voici mes points dans le classement :").."<rgb=#FF5CCD>";
	local count = 0;
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			shareMsg = shareMsg.."\n"..self.score.." pts";
			count = count+1;
		end
	end
	if(count==0) then
		shareMsg = shareMsg.."\n".. FromUTF8("Aucun mort n'a été detecté ! GG !");
	end

	createBubblePopupForSharing("Qui ne Shwing Shwing pas\nn'est pas CHAMPION !", shareMsg, canal):SetVisible(true);
end

function LeaderBoard:Reset()
	self.total = 0;
	for i=self.kmenu:GetItems():GetCount(), 1, -1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			self.kmenu:GetItems():RemoveAt(i);			
		end
	end
	self.total = 0;
end