import "WalmPlugins.BlaBlaCrane.src.LerpValue";
import "WalmPlugins.BlaBlaCrane.src.DeathsCounter";
import "WalmPlugins.BlaBlaCrane.src.KillCounter";
import "WalmPlugins.BlaBlaCrane.src.DiceLister";
import "WalmPlugins.BlaBlaCrane.src.DPSRecorder";
import "WalmPlugins.BlaBlaCrane.src.SkirmishDetector";
import "WalmPlugins.BlaBlaCrane.src.AutoHello";
import "WalmPlugins.BlaBlaCrane.src.ItemReader";
import "WalmPlugins.BlaBlaCrane.src.LeaderBoard";

QuickLauncher = class( Turbine.UI.Window );

function createQuickLauncher(dialog)
	if(QuickLauncherInstance ~=nil) then
		return QuickLauncherInstance;
	end
	QuickLauncherInstance = QuickLauncher(dialog);
	return QuickLauncherInstance;
end

function QuickLauncher:Constructor(dialog)
	Turbine.UI.Window.Constructor( self );
	
	--self.defaultOpacity = 0.6;
	local width, height = Turbine.UI.Display.GetSize();
	self:SetSize(40, 32);
	self:SetPosition(settings.quicklaunch_x, settings.quicklaunch_y);
	self:SetOpacity(settings.defaultOpacity / 100);
	
	local background = Turbine.UI.Label();
	background:SetParent( self );
	background:SetBackground( "WalmPlugins/BlaBlaCrane/ressources/logo.jpg" );
	background:SetPosition( 0, 0 );
	background:SetSize(32, 32);
	background:SetMouseVisible( false );
	background:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	-- self.layer1 = Turbine.UI.Label();
	-- self.layer1:SetParent( background );
	-- self.layer1:SetBackground( "WalmPlugins/LyricalPlusPlus/logo_1.tga" );
	-- self.layer1:SetPosition( 0, 0 );
	-- self.layer1:SetSize(32, 32);
	-- self.layer1:SetMouseVisible( false );
	-- self.layer1:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	-- self.layer2 = Turbine.UI.Label();
	-- self.layer2:SetParent( background );
	-- self.layer2:SetBackground( "WalmPlugins/LyricalPlusPlus/logo_2.tga" );
	-- self.layer2:SetPosition( 0, 0 );
	-- self.layer2:SetSize(32, 32);
	-- self.layer2:SetMouseVisible( false );
	-- self.layer2:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	-- self.layer3 = Turbine.UI.Label();
	-- self.layer3:SetParent( background );
	-- self.layer3:SetBackground( "WalmPlugins/LyricalPlusPlus/logo_3.tga" );
	-- self.layer3:SetPosition( 0, 0 );
	-- self.layer3:SetSize(32, 32);
	-- self.layer3:SetMouseVisible( false );
	-- self.layer3:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	
	
	local contextMenu = Turbine.UI.ContextMenu();
	menuItems = contextMenu:GetItems();
	--local deathMenuItem = Turbine.UI.MenuItem( "Compteur de morts" );
	-- local configMenuItem = Turbine.UI.MenuItem( "Ouvrir le panneau de configuration" );
    --menuItems:Add( deathMenuItem );
    -- menuItems:Add( configMenuItem );
	-- openMenuItem.Click = function(sender, args)
		-- dialog:SetVisible( not dialog:IsVisible() );
	-- end
	-- configMenuItem.Click = function(sender, args)
		-- local configDialog = GetConfigurationDialogInstance();
		-- configDialog:SetVisible(true);
	-- end
	
	self.MouseEnter = function(sender,args)
		--self.button:SetBackground("Chiran/Songbook/toggle_hover.tga");
		self:SetOpacity(1.0);
	end
	self.MouseLeave = function(sender,args)
		--self.button:SetBackground("Chiran/Songbook/toggle.tga");
		self:SetOpacity(settings.defaultOpacity / 100);
	end		
	self.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left and settings.canMoveQuickLauncher) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
			--self:SetBackColor( Turbine.UI.Color(0,0,1,0) );
		end
	end
	self.MouseUp = function( sender, args ) 
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				sender.dragging = false;
			end
			if not sender.dragged and dialog~=nil then
				dialog:SetVisible( not dialog:IsVisible() );
			end
			---self:SetBackColor( Turbine.UI.Color(0,0,0,0) );
			settings.quicklaunch_x, settings.quicklaunch_y = self:GetPosition();
			SaveSettings();
			if(settings.OnUpdate ~= nil) then
				settings.OnUpdate();
			end
			-- TESTING
			createBubblePopup("Hey, ca ne va pas de me\ncliquer sur le crane comme ca ?\nOn a pas élevé les cubitus ensemble !"):SetVisible(true);
		elseif (args.Button == Turbine.UI.MouseButton.Right) then	
			contextMenu:ShowMenu();
		end
	end
	self.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local left, top = self:GetPosition();
			self:SetPosition( left + ( args.X - sender.dragStartX ), top + args.Y - sender.dragStartY );
			sender.dragged = true;
			if (self:GetLeft() > Turbine.UI.Display.GetWidth() - 35) then
				self:SetLeft(Turbine.UI.Display.GetWidth() - 35);				
			end
			if (self:GetLeft() < 0) then
				self:SetLeft(0);				
			end			
			if (self:GetTop() > Turbine.UI.Display.GetHeight() - 35) then
				self:SetTop(Turbine.UI.Display.GetHeight() - 35);				
			end
			if (self:GetTop() < 0) then
				self:SetTop(0);				
			end			
		end
	end
	
	self.lastUpdate = 0;
	self.blinker = LerpValue();
	self.blinker.defaultTimer = 5;
	self.blinker:SetRate(1);
	self.blinker:SetValue(0);
	self.blinker:SetTarget(self.blinker.defaultTimer);
	
	self:Applysettings();
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);			
				end
			end
		end
	end	
	
	if(settings.loadKillCounter==nil or settings.loadKillCounter) then
		local killCounter = KillCounter();
		menuItems:Add(killCounter:GetKillMenu());
	end
	if(settings.loadDeathsCounter==nil or settings.loadDeathsCounter) then
		local deathCounter = DeathsCounter();
		menuItems:Add(deathCounter:GetDeathMenu());	
	end
	if(settings.loadDiceLister==nil or settings.loadDiceLister) then
		local diceLister = DiceLister();
		menuItems:Add(diceLister:GetListMenu());
	end
	if(settings.loadSkirmishDetector==nil or settings.loadSkirmishDetector) then
		local skirmishDetector = SkirmishDetector();
		menuItems:Add(skirmishDetector:GetMenu());
	end
	if(settings.loadAutoHello==nil or settings.loadAutoHello) then
		local autoHello = AutoHello();
		menuItems:Add(autoHello:GetListMenu());
	end
	if(settings.leaderboard==nil or settings.leaderboard) then
		local leaderboard = LeaderBoard();
		menuItems:Add(leaderboard:GetMenu());
	end
	-- if(Turbine.Gameplay.LocalPlayer.GetInstance():GetName()=="Walm") then
		-- local itemReader = ItemReader();
		-- menuItems:Add(itemReader:GetMenu());
	-- end
end

function QuickLauncher:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end

	self.lastUpdate = currentTime;
	
	self.blinker:Update( delta );
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE  - delta=".. delta .." - value="..  math.floor(self.blinker:GetValue()) .."/"..  math.floor(self.blinker:GetTargetValue()) .."</rgb>");
	--self:SetOpacity(self.blinker:GetValue()/100);
	
	self:SetWantsUpdates(settings.animateQuickLauncher);
	
	if (not self.blinker:NeedsUpdate() and settings.animateQuickLauncher) then
		--self.blinker:SetTarget(self.blinker.defaultTimer);
		self.blinker:SetValue(0);
		local bit = math.floor(currentTime%8);
		--Turbine.Shell.WriteLine("<rgb=#FF0000>UPDATE : "..bit .."</rgb>");
		-- self.layer1:SetVisible(bit==1 or bit==4 or bit==5 or bit==7);
		-- self.layer2:SetVisible(bit==2 or bit==4 or bit==6 or bit==7);
		-- self.layer3:SetVisible(bit==3 or bit==5 or bit==6 or bit==7);
	end	
end

function QuickLauncher:Applysettings()
	self:SetPosition(settings.quicklaunch_x, settings.quicklaunch_y);
	self:SetOpacity(settings.defaultOpacity / 100);
	self:SetWantsUpdates(settings.animateQuickLauncher);
	self:SetVisible(settings.useQuickLauncher);
end

function QuickLauncher:GetName()
	return "QuickLauncher";
end

function QuickLauncher:IsRunning()
	return ( self ~= nil );
end

function QuickLauncher:Start()
	if ( self ~= nil ) then
		self:SetVisible( true );
		self:SetWantsUpdates(true);
		return;
	end	
end

function QuickLauncher:Stop()
	self:SetVisible(false);
	self:SetWantsUpdates(false);
	self = nil;
end